<template>
  <article>
    <img :src="product.imageUrl" :alt="product.title" draggable="false">
    <h1>{{ product.title }}</h1>
    <small>{{ formattedPrice }}€ ({{product.price}})</small>
    <hr>
    <p>{{ product.description }}</p>
    <slot>
      <dl>
        <div v-if="amount">
          <dt>Anzahl</dt>
          <dd>{{ amount }}</dd>
        </div>
        <div v-if="remark">
          <dt>Bemerkung</dt>
          <dd>{{ remark }}</dd>
        </div>
      </dl>
    </slot>
    <div v-if="showActions">
      <button type="button" @click="deleteProduct">Delete</button>
    </div>
  </article>
</template>

<script setup>
//defineProps(['product'])
import {computed} from "vue";

const props = defineProps({
  product: {
    type: Object,
    required: true,
    validator(value) {
      return Object.keys(value).every(key => ['imageUrl', 'title', 'description', 'price'].includes(key))
    }
  },
  amount: Number,
  remark: String,
  showActions: Boolean
})

const emit = defineEmits(['delete'])

const formattedPrice = computed(() => new Intl.NumberFormat('de-AT', {minimumFractionDigits: 2}).format(props.product.price))

function deleteProduct() {
  if(confirm('Are you sure')) {
    emit('delete')
  }
}
</script>
